您的位置:首页 > 其它

HDU1171_Big Event in HDU【01背包】

2014-10-22 09:14 218 查看
Big Event in HDU

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 24321    Accepted Submission(s): 8562

Problem Description

Nowadays, we all know that Computer College is the biggest department in HDU. But, maybe you don't know that Computer College had ever been split into Computer College and Software College in 2002.

The splitting is absolutely a big event in HDU! At the same time, it is a trouble thing too. All facilities must go halves. First, all facilities are assessed, and two facilities are thought to be same if they have the same value. It is assumed that there is
N (0<N<1000) kinds of facilities (different value, different kinds).

 

Input

Input contains multiple test cases. Each test case starts with a number N (0 < N <= 50 -- the total number of different facilities). The next N lines contain an integer V (0<V<=50 --value of facility) and an integer M (0<M<=100 --corresponding number of the
facilities) each. You can assume that all V are different.

A test case starting with a negative integer terminates input and this test case is not to be processed.

Output

For each case, print one line containing two integers A and B which denote the value of Computer College and Software College will get respectively. A and B should be as equal as possible. At the same time, you should guarantee that A is not less than B.

 

Sample Input

2

10 1

20 1

3

10 1 

20 2

30 1

-1

 

Sample Output

20 10

40 40

 

Author

lcy

题目大意:有N种设备,每种设备有一个价值和数量。先要将这N种设备按总价值

尽可能的平均分给两个学院。若不能完全平均分,则第一个学院多分一点。

问,两个学院能各能分得多少价值的设备?

思路:每种设备都有一个数量和价值,可以把每一个设备都当做一件物品,比如第

一种设备有M件,价值为V则转换为有M件物品,价值都为V。这样就能转换成01

背包了。把总价值的一半当做背包容量。求最多能装多少价值的物品。因为在尽可

能平分的基础上第一个学院要多分一些。所以结果为第一学院分得sum-dp[sum/2],

第二学院分得dp[sum/2]。

#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;

int V[5050],dp[250050];

int main()
{
int N,v,m,sum;
while(~scanf("%d",&N) && N>0)
{
int num = 0;
sum = 0;
memset(V,0,sizeof(V));
memset(dp,0,sizeof(dp));
for(int i = 0; i < N; i++)
{
scanf("%d%d",&v,&m);
while(m--)
{
V[num++] = v;
sum += v;
}
}
for(int i = 0; i < num; i++)
{
for(int j = sum/2; j >= V[i]; j--)
{
dp[j] = max(dp[j],dp[j-V[i]] + V[i]);
}
}

printf("%d %d\n",sum-dp[sum/2],dp[sum/2]);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: